# MPI_Session_init

Initialize an MPI session

## Synopsis

    int MPI_Session_init(MPI_Info info, MPI_Errhandler errhandler,
                         MPI_Session *session)

## Input Parameters

info
  info object to specify thread support level and MPI implementation specific resources (handle)
errhandler
  error handler to invoke in the event that an error is encountered during this function call (handle)

## Output Parameters

session
  new session (handle)

## Info Hints

## Following keys are supported

"thread_level" - Set MPI thread level. The default is MPI_THREAD_MULTIPLE. Note this is different from the default in MPI_Init. MPICH does not support different thread levels in different sessions. The provided thread level will be the one set by the first MPI_Session_init, MPI_Init, or MPI_Init_thread. "mpi_memory_alloc_kinds" - Set the memory allocation kinds to be used by by the calling MPI process on MPI objects derived from the Session.

## Thread and Interrupt Safety

This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as `malloc` or other non-MPICH runtime routines that are themselves not interrupt-safe.

## Notes for Fortran

All MPI routines in Fortran (except for `MPI_WTIME` and `MPI_WTICK`) have an additional argument `ierr` at the end of the argument list. `ierr` is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the `call` statement.

All MPI objects (e.g., `MPI_Datatype`, `MPI_Comm`) are of type `INTEGER` in Fortran.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarantee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.

MPI_ERR_ARG
  Invalid argument. Some argument is invalid and is not identified by a specific error class (e.g., `MPI_ERR_RANK`).

MPI_ERR_INFO
  Invalid Info

MPI_ERR_OTHER
  Other error; use `MPI_Error_string` to get more information about this error code.